Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/slowproc.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/slowproc.f90	(revision 6594)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/slowproc.f90	(revision 6954)
@@ -3145,35 +3240,305 @@
                    sandfraction(ib) = sandfraction_default
                    siltfraction(ib) = siltfraction_default
+
+                ELSE
+                   IF (fopt == nzobler) THEN
+                      ! All textures are not zero
+                      solt=(/(i,i=1,nzobler)/)
+                   ELSE
+                      DO ilf = 1,fopt
+                         solt(ilf) = vecpos(ilf+1)
+                      END DO
+                   END IF
+                   !
+                   !   Compute the fraction of each textural class
+                   !
+                   sgn = 0.
+                   DO ilf = 1,fopt
+                      !
+                      ! Here we make the correspondance between the 7 zobler textures and the 3 textures in ORCHIDEE
+                      ! and soilclass correspond to surfaces covered by the 3 textures of ORCHIDEE (coase,medium,fine)
+                      ! For type 6 = glacier, default values are set and it is also taken into account during the normalization
+                      ! of the fractions (done in interpweight_2D)
+                      ! Note that type 0 corresponds to ocean but it is already removed using the mask above.
+                     !
+                      IF ( (solt(ilf) .LE. nzobler) .AND. (solt(ilf) .GT. 0) .AND. &
+                           (solt(ilf) .NE. 6) ) THEN
+                         SELECT CASE(solt(ilf))
+                         CASE(1)
+                            soilclass(ib,1) = soilclass(ib,1) + textrefrac(ib,solt(ilf))
+                         CASE(2)
+                            soilclass(ib,2) = soilclass(ib,2) + textrefrac(ib,solt(ilf))
+                         CASE(3)
+                            soilclass(ib,2) = soilclass(ib,2) + textrefrac(ib,solt(ilf))
+                         CASE(4)
+                            soilclass(ib,2) = soilclass(ib,2) + textrefrac(ib,solt(ilf))
+                         CASE(5)
+                            soilclass(ib,3) = soilclass(ib,3) + textrefrac(ib,solt(ilf))
+                         CASE(7)
+                            soilclass(ib,2) = soilclass(ib,2) + textrefrac(ib,solt(ilf))
+                         CASE DEFAULT
+                            WRITE(numout,*) 'We should not be here, an impossible case appeared'
+                            CALL ipslerr_p(3,'slowproc_soilt','Bad value for solt','','')
+                         END SELECT
+                         ! clayfraction is the sum of the % of clay (as a mineral of small granulometry, and not as a texture)
+                         ! over the zobler pixels composing the ORCHIDEE grid-cell
+                         clayfraction(ib) = clayfraction(ib) + &
+                              & textfrac_table(solt(ilf),3) * textrefrac(ib,solt(ilf))
+                         sandfraction(ib) = sandfraction(ib) + &
+                              & textfrac_table(solt(ilf),2) * textrefrac(ib,solt(ilf))
+                         siltfraction(ib) = siltfraction(ib) + &
+                              & textfrac_table(solt(ilf),1) * textrefrac(ib,solt(ilf))
+                         ! Sum the fractions which are not glaciers nor ocean
+                         sgn = sgn + textrefrac(ib,solt(ilf))
+                      ELSE
+                         IF (solt(ilf) .GT. nzobler) THEN
+                            WRITE(numout,*) 'The file contains a soil color class which is incompatible with this program'
+                            CALL ipslerr_p(3,'slowproc_soilt','Problem soil color class incompatible','','')
+                         ENDIF
+                      END IF
+                   ENDDO
+
+                   IF ( sgn .LT. min_sechiba) THEN
+                      ! Set default values if grid cells were only covered by glaciers or ocean
+                      ! or if now information on the source grid was found.
+                      nbexp = nbexp + 1
+                      soilclass(ib,:) = soilclass_default(:)
+                      clayfraction(ib) = clayfraction_default
+                      sandfraction(ib) = sandfraction_default
+                      siltfraction(ib) = siltfraction_default
+                   ELSE
+                      ! Normalize using the fraction of surface not including glaciers and ocean
+                      soilclass(ib,:) = soilclass(ib,:)/sgn
+                      clayfraction(ib) = clayfraction(ib)/sgn
+                      sandfraction(ib) = sandfraction(ib)/sgn
+                      siltfraction(ib) = siltfraction(ib)/sgn
+                   ENDIF
                 ENDIF
-             ENDIF
-
-          ENDDO
-          
-          IF (printlev_loc>=4) WRITE (numout,*) '  slowproc_soilt: End case usda'
-          
-       CASE DEFAULT
-          WRITE(numout,*) 'slowproc_soilt _______'
-          WRITE(numout,*) '  A non supported soil type classification has been chosen'
-          CALL ipslerr_p(3,'slowproc_soilt','non supported soil type classification','','')
-       ENDSELECT
-       IF (printlev_loc >= 5 ) WRITE(numout,*)'  slowproc_soilt end of type classification'
-
-       IF ( nbexp .GT. 0 ) THEN
-          WRITE(numout,*) 'slowproc_soilt:'
-          WRITE(numout,*) '  The interpolation of the bare soil albedo had ', nbexp
-          WRITE(numout,*) '  points without data. This are either coastal points or ice covered land.'
-          WRITE(numout,*) '  The problem was solved by using the default soil types.'
-       ENDIF
-
-       IF (ALLOCATED(variabletypevals)) DEALLOCATE (variabletypevals)
-       IF (ALLOCATED(textrefrac)) DEALLOCATE (textrefrac)
-       IF (ALLOCATED(solt)) DEALLOCATE (solt)
-       IF (ALLOCATED(textfrac_table)) DEALLOCATE (textfrac_table)
-    
-    ENDIF        !      xios_interpolation 
-    
+             ENDDO
+
+             ! The "USDA" case reads a map of the 12 USDA texture classes,
+             ! such as to assign the corresponding soil properties
+          CASE("usda")
+             IF (printlev_loc>=2) WRITE(numout,*) "Using a soilclass map with usda classification"
+
+             soilclass_default=soilclass_default_usda
+
+
+             ALLOCATE(textfrac_table(nscm,ntext), STAT=ALLOC_ERR)
+             IF (ALLOC_ERR/=0) CALL ipslerr_p(3,'slowproc_soilt','Error in allocation for textfrac_table','','')
+
+             CALL get_soilcorr_usda (nscm, textfrac_table)
+
+             IF (printlev_loc>=4) WRITE (numout,*) 'slowproc_soilt: After get_soilcorr_usda'
+             !
+             DO ib =1, nbpt
+                ! GO through the point we have found
+                !
+                ! Provide which textures were found
+                ! vecpos: List of positions where textures were not zero
+                !   vecpos(1): number of not null textures found
+                vecpos = interpweight_ValVecR(textrefrac(ib,:),ntextinfile,zero,'neq')
+                fopt = vecpos(1)
+                !
+                !    Check that we found some points
+                !
+                soilclass(ib,:) = 0.0
+                clayfraction(ib) = 0.0
+                sandfraction(ib) = 0.0
+                siltfraction(ib) = 0.0
+
+                IF ( fopt .EQ. 0) THEN
+                   ! No points were found for current grid box, use default values
+                   IF (printlev_loc>=3) WRITE(numout,*)'slowproc_soilt: no soil class in input file found for point=', ib
+                   nbexp = nbexp + 1
+                   soilclass(ib,:) = soilclass_default
+                   clayfraction(ib) = clayfraction_default
+                   sandfraction(ib) = sandfraction_default
+                   siltfraction(ib) = siltfraction_default
+                ELSE
+                   IF (fopt == nscm) THEN
+                      ! All textures are not zero
+                      solt(:) = (/(i,i=1,nscm)/)
+                   ELSE
+                      DO ilf = 1,fopt
+                         solt(ilf) = vecpos(ilf+1)
+                      END DO
+                   END IF
+
+                   !   Compute the fraction of each textural class
+                   DO ilf = 1,fopt
+                      IF ( (solt(ilf) .LE. nscm) .AND. (solt(ilf) .GT. 0) ) THEN
+                         soilclass(ib,solt(ilf)) = textrefrac(ib,solt(ilf))
+                         clayfraction(ib) = clayfraction(ib) + textfrac_table(solt(ilf),3) *                &
+                              textrefrac(ib,solt(ilf))
+                         sandfraction(ib) = sandfraction(ib) + textfrac_table(solt(ilf),2) * &
+                              textrefrac(ib,solt(ilf))
+                         siltfraction(ib) = siltfraction(ib) + textfrac_table(solt(ilf),1) * &
+                              textrefrac(ib,solt(ilf))
+                      ELSE
+                         IF (solt(ilf) .GT. nscm) THEN
+                            WRITE(*,*) 'The file contains a soil color class which is incompatible with this program'
+                            CALL ipslerr_p(3,'slowproc_soilt','Problem soil color class incompatible 2','','')
+                         ENDIF
+                      ENDIF
+                      !
+                   ENDDO
+
+                   ! Set default values if the surface in source file is too small
+                   IF ( atext(ib) .LT. min_sechiba) THEN
+                      nbexp = nbexp + 1
+                      soilclass(ib,:) = soilclass_default(:)
+                      clayfraction(ib) = clayfraction_default
+                      sandfraction(ib) = sandfraction_default
+                      siltfraction(ib) = siltfraction_default
+                   ENDIF
+                ENDIF
+
+             ENDDO
+
+             IF (printlev_loc>=4) WRITE (numout,*) '  slowproc_soilt: End case usda'
+
+          CASE DEFAULT
+             WRITE(numout,*) 'slowproc_soilt _______'
+             WRITE(numout,*) '  A non supported soil type classification has been chosen'
+             CALL ipslerr_p(3,'slowproc_soilt','non supported soil type classification','','')
+          ENDSELECT
+          IF (printlev_loc >= 5 ) WRITE(numout,*)'  slowproc_soilt end of type classification'
+
+          IF ( nbexp .GT. 0 ) THEN
+             WRITE(numout,*) 'slowproc_soilt:'
+             WRITE(numout,*) '  The interpolation of variable soiltext had ', nbexp
+             WRITE(numout,*) '  points without data. This are either coastal points or ice covered land.'
+             WRITE(numout,*) '  The problem was solved by using the default soil types.'
+          ENDIF
+
+          IF (ALLOCATED(variabletypevals)) DEALLOCATE (variabletypevals)
+          IF (ALLOCATED(textrefrac)) DEALLOCATE (textrefrac)
+          IF (ALLOCATED(solt)) DEALLOCATE (solt)
+          IF (ALLOCATED(textfrac_table)) DEALLOCATE (textfrac_table)
+
+       ENDIF        !      xios_interpolation
+
+       !salma: calculate njsc
+       njsc(:) = 0
+       DO ib = 1, nbpt
+          njsc(ib) = MAXLOC(soilclass(ib,:),1)
+       ENDDO
+
+       IF (spmipexp == 'exp1') THEN
+              IF (printlev_loc>=3) WRITE (numout,*) 'slowproc_soilt: Read soil hydraulic parameters with IOIPSL'
+
+              ! Read using IOIPSL and interpolate using aggregate tool in ORCHIDEE
+
+              !Config Key   = PARAM_FILE
+              !Config Desc  = Name of file from which soil parameter  values are read
+              !Config Def   = params_sp_mip.nc
+              !Config Help  = The name of the file to be opened to read values of parameters.
+              !Config         The data from this file is then interpolated to the grid of
+              !Config         of the model.
+              !Config Units = [FILE]
+              !
+              ! params_sp_mip.nc file is 0.5 deg soil hydraulic parameters file provided by sp_mip
+
+              filename = 'params_sp_mip.nc'
+              CALL getin_p('PARAM_FILE',filename)
+
+              !! Variables for interpweight
+              ! Type of calculation of cell fractions
+              fractype = 'default'
+              ! Name of the longitude and latitude in the input file
+              lonname = 'nav_lon'
+              latname = 'nav_lat'
+              ! Assigning values to vmin, vmax (there are not types/categories
+              vmin =0.
+              vmax = 99999.
+              !! Variables for interpweight
+              ! Should negative values be set to zero from input file?
+              nonegative = .FALSE.
+              ! Type of mask to apply to the input data (see header for more details)
+              maskingtype = 'mabove'
+              ! Values to use for the masking
+              maskvals = (/ min_sechiba, undef_sechiba, undef_sechiba /)
+              ! Name of the variable with the values for the mask in the input file (only if maskkingtype='var') ( not used)
+              namemaskvar = ''
+
+              variablename = 'ks'
+              IF (printlev_loc >= 1) WRITE(numout,*) "slowproc_soilt: Read and interpolate " &
+                   // TRIM(filename) // " for variable " // TRIM(variablename)
+              CALL interpweight_2Dcont(nbpt, 0, 0, lalo, resolution, neighbours,                                &
+                   contfrac, filename, variablename, lonname, latname, vmin, vmax, nonegative, maskingtype,     &
+                   maskvals, namemaskvar, -1, fractype, 0., 0.,                              &
+                   ks, aparam)
+              WRITE(numout,*) 'ks map is read _______'
+
+              variablename = 'alpha'
+              CALL interpweight_2Dcont(nbpt, 0, 0, lalo, resolution, neighbours,                                &
+                   contfrac, filename, variablename, lonname, latname, vmin, vmax, nonegative, maskingtype,     &
+                   maskvals, namemaskvar, -1, fractype, 0., 0.,                              &
+                   avan, aparam)
+              WRITE(numout,*) 'avan map read _______'
+
+              variablename = 'thetar'
+              CALL interpweight_2Dcont(nbpt, 0, 0, lalo, resolution, neighbours,                                &
+                   contfrac, filename, variablename, lonname, latname, vmin, vmax, nonegative, maskingtype,     &
+                   maskvals, namemaskvar, -1, fractype, 0., 0.,                              &
+                   mcr, aparam)
+              WRITE(numout,*) 'thetar map read _______'
+
+              variablename = 'thetas'
+              CALL interpweight_2Dcont(nbpt, 0, 0, lalo, resolution, neighbours,                                &
+                   contfrac, filename, variablename, lonname, latname, vmin, vmax, nonegative, maskingtype,     &
+                   maskvals, namemaskvar, -1, fractype, 0., 0.,                              &
+                   mcs, aparam)
+              WRITE(numout,*) 'thetas map read _______'
+
+              variablename = 'thetapwpvg'
+              CALL interpweight_2Dcont(nbpt, 0, 0, lalo, resolution, neighbours,                                &
+                   contfrac, filename, variablename, lonname, latname, vmin, vmax, nonegative, maskingtype,     &
+                   maskvals, namemaskvar, -1, fractype, 0., 0.,                              &
+                   mcw, aparam)
+              WRITE(numout,*) 'thetapwpvg map read _______'
+
+              variablename = 'thetafcvg'
+              CALL interpweight_2Dcont(nbpt, 0, 0, lalo, resolution, neighbours,                                &
+                   contfrac, filename, variablename, lonname, latname, vmin, vmax, nonegative, maskingtype,     &
+                   maskvals, namemaskvar, -1, fractype, 0., 0.,                              &
+                   mcfc, aparam)
+              WRITE(numout,*) 'thetafcvg map read _______'
+
+              variablename = 'nvg'
+              CALL interpweight_2Dcont(nbpt, 0, 0, lalo, resolution, neighbours,                                &
+                   contfrac, filename, variablename, lonname, latname, vmin, vmax, nonegative, maskingtype,     &
+                   maskvals, namemaskvar, -1, fractype, 0., 0.,                              &
+                   nvan, aparam)
+              WRITE(numout,*) 'nvan map read _______'
+
+      ELSE
+          IF (spmipexp == 'exp2') THEN
+            ! Texture map from SP-MIP, thus Soilgrids modified
+            nvan(:) = nvan_usda(njsc(:))
+            avan(:) = avan_usda(njsc(:))
+            mcr(:) = mcr_usda(njsc(:))
+            mcs(:) = mcs_usda(njsc(:))
+            ks(:) = ks_usda(njsc(:))
+            mcfc(:) = mcf_usda(njsc(:))
+            mcw(:) = mcw_usda(njsc(:))
+            ! on aura pcent(:) = pcent(njsc(:)) dans hydrol
+         ELSE
+            ! salma: here we are in exp3 -- Zobler map
+            nvan(:) = nvan_fao(njsc(:))
+            avan(:) = avan_fao(njsc(:))
+            mcr(:) = mcr_fao(njsc(:))
+            mcs(:) = mcs_fao(njsc(:))
+            ks(:) = ks_fao(njsc(:))
+            mcfc(:) = mcf_fao(njsc(:))
+            mcw(:) = mcw_fao(njsc(:))
+
+          ENDIF !if EXP2
+       ENDIF !if EXP1
+     ENDIF !if EXP4
+             
     ! Write diagnostics
     CALL xios_orchidee_send_field("atext",atext)
-
     CALL xios_orchidee_send_field("interp_diag_atext",atext)
     CALL xios_orchidee_send_field("interp_diag_soilclass",soilclass)
@@ -3585,5 +3950,5 @@
     !! 0.4 Local variables
 
-    INTEGER(i_std),PARAMETER :: nbtypes_usda = 12                    !! Number of USDA texture classes (unitless)
+    INTEGER(i_std),PARAMETER :: nbtypes_usda = 13                    !! Number of USDA texture classes (unitless)
     INTEGER(i_std) :: n                                              !! Index (unitless)
     
@@ -3619,4 +3984,5 @@
     textfrac_table(11,2:3) = (/ 0.06, 0.46 /) ! Silty Clay
     textfrac_table(12,2:3) = (/ 0.15, 0.55 /) ! Clay
+    textfrac_table(13,2:3) = (/ 0.15, 0.55 /) ! Clay
 
     ! Fraction of silt
Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/thermosoil.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/thermosoil.f90	(revision 6594)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/thermosoil.f90	(revision 6954)
@@ -389,5 +389,5 @@
        so_capa_dry_ns(:) = so_capa_dry_ns_fao(:)
        mcs(:) = mcs_fao(:)
-    CASE (12)
+    CASE (13) !Salma changed from 12 to 13 for the new class Oxisols
        SMCMAX(:) = SMCMAX_usda(:)
       QZ(:) = QZ_usda(:)
